#include <bits/stdc++.h>

using namespace std;

#define V vector

#define rmin(a, b) a = min(a, b)
#define rmax(a, b) a = max(a, b)

#define rep(i, lim) for (size_t i = 0; i < (lim); i++)
#define nrep(i, s, lim) for (size_t i = s; i < (lim); i++)

#define repv(i, v) for (auto &i : (v))
#define fillv(v) for (auto &itr_ : (v)) { cin >> itr_; }
#define sortv(v) sort(v.begin(), v.end())
#define all(v) (v).begin(), (v).end()

using vi = vector<int>;
using vvi = vector<vi>;
using vvvi = vector<vvi>;
using vvvvi = vector<vvvi>;

using ll = long long;

using vl = vector<ll>;
using vvl = vector<vl>;
using vvvl = vector<vvl>;
using vvvvl = vector<vvvl>;

template<class v>
auto operator<<(ostream &os, const vector<v> &vec)->ostream& {
    os << vec[0];
    for (size_t i = 1; i < vec.size(); i++) {
        os << ' ' << vec[i];
    }
    os << '\n';
    return os;
}

template<class v>
auto operator>>(istream &is, vector<v> &vec)->istream& {
    for (auto &i : vec) {
        is >> i;
    }
    return is;
}

template<class v>
auto operator<<(ostream &os, const vector<vector<v>> &vec)->ostream& {
    for (auto &i : vec) {
        os << i[0];
        for (size_t j = 1; j < i.size(); j++) {
            os << ' ' << i[j];
        }
        os << '\n';
    }
    return os;
}

template<class v>
auto operator>>(istream  &is, vector<vector<v>> &vec)->istream& {
    for (auto &i : vec) {
        for (auto &j : i) {
            is >> j;
        }
    }
    return is;
}

int main()
{
    ios::sync_with_stdio(false);
    cin.tie(nullptr);

    int n, m;
    cin >> n >> m;

    vvl plates(n);
    vl maxi(n, 0);
    vvl prefix(n);

    rep(i, n) {
        int n;
        cin >> n;
        plates[i].resize(n);
        prefix[i].resize(n + 1);
        prefix[i][0] = 0;
        for (size_t j = 0; j < n; j++) {
            cin >> plates[i][j];
            prefix[i][j + 1] = prefix[i][j] + plates[i][j];
            maxi[i] += plates[i][j];
        }
    }

    vvl dp(n, vl(101, 0));
    for (size_t i = 0; i < n; i++) {
        dp[i][plates[i].size()] = maxi[i];
        for (size_t j = 0; j < plates[i].size(); j++) {
            for (size_t k = j; k < plates[i]. size(); k++) {
                rmax(dp[i][plates[i].size() - (k - j + 1)], maxi[i] - prefix[i][k + 1] + prefix[i][j]);
            }
        }
        for (size_t j = plates[i].size() + 1; j <= 100; j++) {
            dp[i][j] = dp[i][j - 1];
        }
    }
    // cout << dp;

    vvl ans(n + 1, vl(m + 1, 0));
    for (size_t i = 1; i <= n; i++) {
        for (size_t j = 1; j <= m; j++) {
            for (size_t k = 0; k <= j && k <= 100; k++) {
                rmax(ans[i][j], ans[i - 1][j - k] + dp[i - 1][k]);
            }
        }
    }
    cout << ans[n][m] << '\n';
}
